/* 
 * Motif Tools Library, Version 2.0
 * $Id: DialogP.h,v 2.10 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#ifndef _XmtDialogP_h
#define _XmtDialogP_h

#include <Xmt/Dialog.h>
#include <Xmt/Dialogs.h>
#include <Xmt/WidgetType.h>

/*
 * We associate one of these structures with each shell widget
 * We build the structure up as we create the children.
 */
typedef struct {
    XtResourceList resources;  /* a compiled resource list */
    WidgetList widgets;        /* one child widget for each resource */
    XmtWidgetType **types;     /* a type for each widget */
    short num_resources;
    XtPointer base;            /* set by XmtDialogDo */
    Boolean return_value;
    Boolean blocking;
} XmtDialogInfo;

_XFUNCPROTOBEGIN
#if NeedFunctionPrototypes
extern XmtDialogInfo *_XmtDialogLookupDialogInfo(Widget);
#else
extern XmtDialogInfo *_XmtDialogLookupDialogInfo();
#endif
_XFUNCPROTOEND

#endif   
