/* 
 * Motif Tools Library, Version 2.0
 * $Id: LayoutCreate.c,v 2.9 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#include <Xmt/XmtP.h>
#include <Xmt/LayoutP.h>
#include <Xmt/WidgetType.h>

/*
 * These methods are registered indirectly like this so that
 * the XmtLayout widget is not dependent on, and linked with
 * all of WidgetType.c  If the widget is being used with the rest
 * of Xmt, and if the programmer wants this creation feature, he
 * can call this function to arrange for the widget to get it.
 * Note that this needs to be a separate file, or everything will
 * get linked in whether registered or not.
 */
#if NeedFunctionPrototypes
void XmtRegisterLayoutCreateMethod(void)
#else
void XmtRegisterLayoutCreateMethod()
#endif
{
    xmtLayoutClassRec.layout_class.lookup_type_proc =
	(XmtLayoutLookupTypeProc) XmtLookupWidgetType;
    xmtLayoutClassRec.layout_class.create_proc =
	(XmtLayoutCreateProc) XmtCreateWidgetType;
}
