/* 
 * Motif Tools Library, Version 2.0
 * $Id: MenuP.h,v 2.9 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#ifndef _XmtMenuP_h
#define _XmtMenuP_h    

#include <Xm/XmP.h>
#include <Xm/RowColumnP.h>
#include <Xmt/Menu.h>

typedef struct _XmtMenuClassPart {
    XtPointer extension;
} XmtMenuClassPart;

typedef struct _XmtMenuClassRec {
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart		constraint_class;
    XmManagerClassPart		manager_class;
    XmRowColumnClassPart	row_column_class;
    XmtMenuClassPart            menu_class;
} XmtMenuClassRec;

externalref XmtMenuClassRec xmtMenuClassRec;

typedef struct _XmtMenuPart {
    /* resources */
    XmtMenuItem *items;
    int num_items;
    String accelerator_font_tag;
} XmtMenuPart;

typedef struct _XmtMenuRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XmManagerPart	manager;
    XmRowColumnPart	row_column;
    XmtMenuPart         menu;
} XmtMenuRec;

#endif /* _XmtMenuP_h */
