/* 
 * Motif Tools Library, Version 2.0
 * $Id: ScreenP.h,v 2.9 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#ifndef _XmtScreenP_h
#define _XmtScreenP_h

#include <Xmt/DialogsP.h>

typedef struct {
    Widget topmost_shell;  /* used as dialog parent */
    XmtDialogCache help_dialog_cache;
    Widget working_dialog;
    Widget string_dialog;     /* dialog for XmtAskForString() */
    Widget boolean_dialog;    /* dialog for XmtAskForBoolean() */
    Widget file_dialog;       /* dialog for by XmtAskForFilename() */
    Widget item_dialog;       /* dialog for XmtAskForItem[Number]() */
    struct {                  /* internal widgets of the boolean dialog */
	Widget icon, message;
	Widget yes, no, cancel, help;
	Boolean show_cancel_button;
    } boolean_internals;
    Boolean blocked;          /* flag for recursive event loops */
    XmtButtonType button;     /* which button was pressed */
    StringConst help_text;    /* help message used by _XmtHelpCallback() */
    StringConst file_mode;    /* whether and how to open the FSB file */
    FILE *selected_file;      /* temp. storage for the opened file */
} XmtPerScreenInfo;

_XFUNCPROTOBEGIN
#if NeedFunctionPrototypes
extern XmtPerScreenInfo *XmtGetPerScreenInfo(Widget);
#else
extern XmtPerScreenInfo *XmtGetPerScreenInfo();
#endif
_XFUNCPROTOEND

#endif /* _XmtScreenP_h */
