/* 
 * Motif Tools Library, Version 2.0
 * $Id: WorkingBoxP.h,v 2.9 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#ifndef _XmtWorkingBoxP_h
#define _XmtWorkingBoxP_h    

#include <Xmt/LayoutP.h>
#include <Xmt/WorkingBox.h>

typedef struct _XmtWorkingBoxClassPart {
    XtPointer extension;
} XmtWorkingBoxClassPart;

typedef struct _XmtWorkingBoxClassRec {
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart	        constraint_class;
    XmManagerClassPart	        manager_class;
    XmBulletinBoardClassPart    bulletin_class;
    XmtLayoutClassPart          layout_class;
    XmtWorkingBoxClassPart      working_box_class;
} XmtWorkingBoxClassRec;

externalref XmtWorkingBoxClassRec xmtWorkingBoxClassRec;

typedef struct _XmtWorkingBoxPart {
    /* resources */
    String message;
    String scale_label;
    String button_label;
    Pixmap icon;
    Boolean show_scale;
    Boolean show_button;
    int scale_value;
    int scale_min, scale_max;
    /* widgets */
    Widget pixmap;
    Widget scale;
    Widget separator;
    Widget button;
    /* private state */
    Boolean button_pressed;
    Boolean free_icon;
} XmtWorkingBoxPart;

typedef struct _XmtWorkingBoxRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart      constraint;
    XmManagerPart       manager;
    XmBulletinBoardPart	bulletin_board;
    XmtLayoutPart       layout;
    XmtWorkingBoxPart   working_box;
} XmtWorkingBoxRec;

#endif /* _XmtWorkingBoxP_h */
