/* 
 * Motif Tools Library, Version 2.0
 * $Id: XtProcs.c,v 2.9 1994/07/04 03:03:50 david Exp $
 * 
 * Written by David Flanagan.
 * Copyright (c) 1992, 1993, 1994 by Dovetail Systems.
 * All Rights Reserved.  See the file COPYRIGHT for details.
 * This is not free software.  See the file SHAREWARE for details.
 * There is no warranty for this software.  See NO_WARRANTY for details.
 */

#include <stdio.h>
#include <Xmt/Xmt.h>
#include <Xmt/Procedures.h>


static XmtProcedureInfo xt_procedures[] = {
{"XtManageChild", (XmtProcedure) XtManageChild, {XtRWidget}},
{"XtUnmanageChild", (XmtProcedure) XtUnmanageChild, {XtRWidget}},
{"XtSetSensitive", (XmtProcedure) XtSetSensitive, {XtRWidget, XtRBoolean}},
{"XtDestroyWidget", (XmtProcedure) XtDestroyWidget, {XtRWidget}},
{"XtAugmentTranslations", (XmtProcedure)XtAugmentTranslations,
    {XtRWidget, XtRTranslationTable}},
{"XtOverrideTranslations", (XmtProcedure)XtOverrideTranslations,
    {XtRWidget, XtRTranslationTable}},
{"XtPopupExclusive", (XmtProcedure)XtCallbackExclusive,
    {XmtRCallbackWidget, XtRWidget}},
{"XtPopupNonexclusive", (XmtProcedure)XtCallbackNonexclusive,
    {XmtRCallbackWidget, XtRWidget}},
{"XtPopupNone", (XmtProcedure)XtCallbackNone,
    {XmtRCallbackWidget, XtRWidget}},
{"XtPopupSpringLoaded", (XmtProcedure)XtPopupSpringLoaded, {XtRWidget}},
{"XtPopdown", (XmtProcedure)XtPopdown, {XtRWidget}},
{"XtAddCallbacks", (XmtProcedure)XtAddCallbacks,
     {XtRWidget, XtRString, XtRCallback}},
/* can't have XtRemoveCallback() because we'll never get matching client_data*/
{"XtError", (XmtProcedure)XtError, {XtRString}},
{"XtWarning", (XmtProcedure)XtWarning, {XtRString}},
{"XtInstallAccelerators", (XmtProcedure)XtInstallAccelerators,
     {XtRWidget, XtRWidget}},
{"XtInstallAllAccelerators", (XmtProcedure)XtInstallAllAccelerators,
     {XtRWidget, XtRWidget}},
{"XtSetMappedWhenManaged", (XmtProcedure)XtSetMappedWhenManaged,
     {XtRWidget, XtRBoolean}},
{"XtSetKeyboardFocus", (XmtProcedure)XtSetKeyboardFocus,
     {XtRWidget, XtRWidget}},
{"XtRealizeWidget", (XmtProcedure)XtRealizeWidget, {XtRWidget}},
};


#if NeedFunctionPrototypes
void XmtRegisterXtProcedures(void)
#else
void XmtRegisterXtProcedures()
#endif
{
    XmtRegisterProcedures(xt_procedures, XtNumber(xt_procedures));
}
