! This is a "global" font list that contains every font I might
! want to use in my application.  Having declared it, I can use
! these fonts by name in any XmString with the "@f" font changing
! escape code:  @fBThis is bold text@fR, @f[HUGE]This is huge text@fR
*FontList: *-new century schoolbook-medium-r-*-*-*-140-*=R,\
           *-new century schoolbook-bold-r-*-*-*-140-*=B,\
	   *-new century schoolbook-medium-i-*-*-*-140-*=I,\
	   *-new century schoolbook-medium-r-*-*-*-180-*=BIG,\
	   *-new century schoolbook-medium-r-*-*-*-240-*=HUGE,\
	   *-helvetica-medium-r-*-*-*-120-*=H\
	   *-helvetica-bold-r-*-*-*-120-*=HB


! The name of this application is "demo", and this is also the name of
! the toplevel shell widget.  This shell widget has one normal child: an
! XmtLayout widget named "layout".  It also has a number of dialog shells
! that we'll use later for parts of the demo that pop up in separate 
! windows.
demo.xmtChildren: XmtLayout layout;\
		  XmDialogShell choosershell, workingshell, inputshell;\
		  XmDialogShell frameshell, captionshell;

! The XmtLayout widget has 3 children: a menubar, a command-line
! interface and a message line.
*layout.xmtChildren: \
		XmtMenubar menubar; \
		XmtCli cli; \
		XmtMsgLine msgline;

! These three children are laid out one on top of the other.
! This is a very simple layout that doesn't demonstrate the 
! features of the XmtLayout widget.
*layout.layout: \
	Fixed menubar \
Centered "@fHThis application demonstrates some of the features of the Xmt\n\
library.  The @f(HBXmtCli@fH and @f(HBXmtMsgLine@fH widgets appear below,\n\
and other widgets are demonstrated when you select items from\nthe menus." #\
	cli\
	Fixed msgline


! The menubar has these pulldown menus in it:
! The '_' character in the strings preceeds the mnemonic character
! for an item.  The "Help" menu has the special "Help" flag set which
! places it at the far right of the menubar.
*menubar.items: \
	"_File" -> file ;\
	"_Dialogs" -> dialogs ;\
	"_Widgets" -> widgets ;\
   Help	"_Help" -> help ;

! The "file" menu pane is automatically created as a child of the
! menubar by the specification above.  This pane has the following
! items.  The specification in square brackets is an accelerator,
! and the exit function will be called through the Xmt
! string-to-callback converter when this item is selected.
*file.items:\
	"_Quit" [Ctrl-C] exit(0);

! The "dialogs" menu pane is also automatically created.
! The items in this menu pop up some demo dialogs
*dialogs.items: \
	"Warning"    XmtDisplayWarning(warning, This is a warning dialog);\
	"Error"	     XmtDisplayError(error, This is an error dialog);\
	"Information" XmtDisplayInformation(info, Information here., Help); \

! The "widgets" menu pane pops up other shells that contain some widget demos
*widgets.items: \
	"XmtChooser"	XtManageChild(*chooserdemo);\
	"XmtInputField" XtManageChild(*inputdemo);\
	"XmtWorkingBox" XtManageChild(*workingdemo);\
	"XmtLayout Frames"   XtManageChild(*framedemo);\
	"XmtLayout Captions" XtManageChild(*captiondemo);

! help isn't implemented right now
*help.items: \
	"About" XmtDisplayInformation(nyi, Not Yet Implemented, NYI);\
	"Context Help" XmtDisplayInformation(nyi, Not Yet Implemented, NYI); \
	"Help on Topic" XmtDisplayInformation(nyi, Not Yet Implemented, NYI);

! We can specify fonts for the menu items in the item strings themselves.
! To specify the font to use for menu accelerators, however, we need to
! set the acceleratorFontTag resource.  Note we use '*' to set it on all
! XmtMenu widgets automatically created by the original menubar widget.
! Here, we use helvetica bold to make the accelerators stand out.
*menubar*acceleratorFontTag: HB

!
! Now we set up the XmtCli widget with a size, some basic instructions,
! and a prompt.  We use a caption provided by the XmtLayout widget for the
! prompt.
!
*cli.columns: 60
*cli.rows: 10
*cli.prompt: demo> 
*cli.layoutCaptionPosition: Top
*cli.layoutCaptionJustification: Left
*cli.layoutCaption: \
This is an @fBXmtCli@fR widget.  It has a prompt, and you can type command\n\
lines at the prompt.  (Whatever you type is ignored in this demo, however.)\n\
Note that the up and down arrow keys provide a command history mechanism,\n\
like that provided by some shells.  Note that you can edit the current line,\n\
but can't backspace over the prompt, or move the cursor onto earlier lines.

!
! Now the XmtMsgLine
!
*msgline.value: This is an XmtMsgLine widget.  It doesn't do much in this demo.

!---------------------------------------------------------------------------
! The choosers demo
!---------------------------------------------------------------------------

! Note that we create the child of this dialog unmanaged.  This is so we
! can manage it later, when we actually want this dialog to pop up.
*choosershell.xmtChildren: unmanaged XmtLayout chooserdemo;
*chooserdemo.xmtChildren: XmtChooser c1, c2, c3, c4, c5, c6, c7, c8;
*chooserdemo.layout: \
Line Bottom 2 4 "@f[HUGE]XmtChooser Demo"\
"This dialog contains eight XmtChooser widgets, each with a different\n\
value for its @fHXmtNchooserType@fR resource.  The XmtChooser widget is\n\
very easy to use because the choices that appear in it are specified\n\
simply as a list of strings, and because there is a single resource that\n\
you can query to find out what the user has chosen."\
Row{ c1 c2 c3 c4 } \
Row{c5 c6 c7 c8}\
=\
FlushRight XmPushButton Done

*chooserdemo*XmtChooser.strings: "item1", "item2", "item3", "item4"
*chooserdemo*XmtChooser.layoutFrameType: Box
*chooserdemo*XmtChooser.layoutFrameLineType: EtchedIn
*chooserdemo*XmtChooser.layoutFrameThickness: 4
*chooserdemo*XmtChooser.layoutFramePosition: Through
*chooserdemo*XmtChooser.layoutCaptionPosition: Top
*chooserdemo*XmtChooser.layoutCaptionJustification: Left
*chooserdemo*XmtChooser.layoutWidth: 100

*chooserdemo*c1.chooserType: RadioBox
*chooserdemo*c2.chooserType: CheckBox
*chooserdemo*c3.chooserType: RadioList
*chooserdemo*c4.chooserType: CheckList
*chooserdemo*c5.chooserType: RadioPalette
*chooserdemo*c6.chooserType: CheckPalette
*chooserdemo*c7.chooserType: Option
*chooserdemo*c8.chooserType: ButtonBox

*chooserdemo*c1.layoutCaption: @fB Radio Box @fR 
*chooserdemo*c2.layoutCaption: @fB Check Box @fR
*chooserdemo*c3.layoutCaption: @fB Radio List @fR
*chooserdemo*c4.layoutCaption: @fB Check List @fR
*chooserdemo*c5.layoutCaption: @fB Radio Palette @fR
*chooserdemo*c6.layoutCaption: @fB Check Palette @fR
*chooserdemo*c7.layoutCaption: @fB Option Menu @fR
*chooserdemo*c8.layoutCaption: @fB Button Box @fR

!---------------------------------------------------------------------------
! The input field demo
!---------------------------------------------------------------------------
*inputshell.xmtChildren: unmanaged XmtLayout inputdemo;
*inputdemo.xmtChildren: XmtInputField input1, input2, input3;\
			XmtInputField input4, input5, input6;
*inputdemo.layout: \
Line Bottom 2 4 "@f[HUGE]XmtInputField Demo"\
LREvenSpaced Row { \
	"This is a plain XmtInputField.\nType anything"\
	Etched Outside Caption "First name:" input1}\
LREvenSpaced Row { \
	"This one converts to all caps."\
	Etched Outside Caption "Last name:" input2}\
LREvenSpaced Row { \
	"This one uses overstrike mode."\
	Etched Outside Caption "Address:" input3}\
LREvenSpaced  Row { \
	"If you don't type a full phone\nnumber this one says 'Error'"\
	Etched Outside Caption "Work phone:" input4}\
LREvenSpaced Row { \
	"This one changes color on bad input\n(On color screens only.)" \
	Etched Outside Caption "Home phone:" input5}\
LREvenSpaced Row { \
	"This one reverts to the last valid\ninput on error."\
	Etched Outside Caption "Date (mm/dd/yy):" input6 }\
= FlushRight XmPushButton Done

! These resources say accept up to 20 letter, convert them to capitals
! but don't require that the user type exactly 20 characters
*inputdemo.input2.pattern: AAAAAAAAAAAAAAAAAAAA
*inputdemo.input2.matchAll: False

*inputdemo.input3.overstrike: True

*inputdemo.input4.pattern: (ddd) ddd-dddd
*inputdemo.input4.errorString: <Error>
*inputdemo.input4.replaceOnError: False

*inputdemo.input5.pattern: (ddd) ddd-dddd
*inputdemo.input5.highlightOnError: True
*inputdemo.input5.errorForeground: maroon
*inputdemo.input5.replaceOnError: False

*inputdemo.input6.pattern: dd/dd/dd

!---------------------------------------------------------------------------
! The working box demo
!---------------------------------------------------------------------------
*workingshell.xmtChildren: unmanaged XmtWorkingBox workingdemo;
*workingdemo.message:\
This is an @fBXmtWorkingBox@fR widget.  It is used\n\
When the application is busy and is not handling user\n\
events.  The application can optionally display its\n\
progress in the slider below, and can optionally display\n\
the pushbutton below to let the user abort the operation.\n\
This demo doesn't actually do anything; it just pops up the\n\
widget.

!---------------------------------------------------------------------------
! The frames demo
!---------------------------------------------------------------------------
*frameshell.xmtChildren: unmanaged XmtLayout framedemo;
*framedemo.xmtChildren: XmLabel l1, l2, l3, l4, l5, l6;
*framedemo.layout: \
Line Bottom 2 4 "@f[HUGE]XmtLayout Frames Demo"\
"This dialog demonstrates the different types of frames\n\
That the XmtLayout widget can draw around any of its children.\n\
By default, frames are drawn as a box all the way around a\n\
child, but they can also be drawn as a single line against any\n\
one side of the child.  The thick line above, and the etched line\n\
near the bottom of this dialog are drawn by the XmtLayout widget\n\
in this way."\
Row { Shadowed l1 Shadowed Out l2 } \
Row { Etched l3 Etched Out l4 } \
Row { Boxed l5 DoubleBoxed l6} \
#\
Etched Top Row { <> XmPushButton Done }

! experiment with the frame thickness here:
*framedemo.XmLabel.layoutFrameThickness: 4

*framedemo.l1.labelString: Shadow In
*framedemo.l2.labelString: Shadow Out
*framedemo.l3.labelString: Etched In
*framedemo.l4.labelString: Etched Out
*framedemo.l5.labelString: Single Line
*framedemo.l6.labelString: Double Line


!---------------------------------------------------------------------------
! The captions demo
!---------------------------------------------------------------------------
*captionshell.xmtChildren: unmanaged XmtLayout captiondemo;
*captiondemo.xmtChildren: XmPushButton b1, b2, b3, b4, b5, b6, b7, b8, b9;\
			  XmPushButton b10, b11, b12, b13, b14, b15, b16;
*captiondemo*XmPushButton.layoutWidth: 75
*captiondemo*XmPushButton.layoutHeight: 75

*captiondemo.layout: \
Line Bottom 2 4 "@f[HUGE]XmtLayout Captions Demo"\
"The @fBXmtLayout@fR widget can draw a caption for any of its\n\
children.  There are a number of parameters that control how these\n\
captions are drawn."\
Etched Through Caption tll "@fBCaption Position" Row {\
	Caption lll "Left" b1\
	Caption tll "Top" b2\
	Caption rll "Right" b3\
	Caption bll "Bottom" b4\
} #\
Etched Through Caption tll "@fBCaption Justification" Row {\
	Caption tll "Left" b5\
	Caption tcl "Center" b6\
	Caption trl "Right" b7\
	Caption ltl "Top" b8\
	Caption lcl "Center" b9\
	Caption lrl "Bottom" b10\
} #\
Etched Through Caption tll "@fBCaption Alignment" Row {\
	Caption lll "Left\nAligned\nCaption" b11\
	Caption llc "Center\nAligned\nCaption" b12\
	Caption llr "Right\nAligned\nCaption" b13\
} #\
Etched Through Caption tll "@fBRelative Frame Position" Row {\
	Caption llr "Frame\nInside\nCaption" Boxed Inside b14\
	Caption llr "Frame\nOutside\nCaption" Boxed Outside b15\
	Caption llr "Frame\nThrough\nCaption" Boxed Through b16\
} #\
= FlushRight XmPushButton Done


!
! We shouldn't need to set this resource; this is a work around to a bug
! that I'll fix for the next release
!
*cli.editMode: XmMULTI_LINE_EDIT
