/*
 *	Example code to demonstrate toggling between two pixmaps in a label
 *	by toggling its sensitivity.
 *
 *	Note:  This code is hereby contributed to the public domain.
 *	Author:	Greg Ullmann
 */

#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>

/*
 *	This pushbutton callback toggles the pixmaps on the label
 */
/*ARGSUSED*/
void
switchCB(Widget w, XtPointer clientData, XtPointer callData)
{
	Widget	lbl = (Widget) clientData;

	XtSetSensitive(lbl, !XtIsSensitive(lbl));
}

int
main(int ac, char **av)
{
	Widget	toplevel;
	Widget	rc;
	Widget	pb;
	Widget	lbl;

	/* create the container */
	toplevel = XtInitialize(av[0], "Label", NULL, 0, &ac, av);
	rc = XmCreateRowColumn(toplevel, "rc", NULL, 0);

	/* see the resource file for setting the pixmaps */
	lbl = XmCreateLabel(rc, "state", NULL, 0);

	/* create the button to toggle between states */
	pb = XmCreatePushButton(rc, "Switch", NULL, 0);

	/* add the callback to the pushbutton to switch states */
	XtAddCallback(pb, XmNactivateCallback, switchCB, (XtPointer) lbl);

	/* now manage everything and go */
	XtManageChild(lbl);
	XtManageChild(pb);
	XtManageChild(rc);
	XtRealizeWidget(toplevel);

	XtMainLoop();

	/*NOTREACHED*/
}
